// pages/userCenter.js
const app = getApp()
const wxService = require('../../utils/wxService')
const utils = require('../../utils/util')
const envInfo = require('../../config/index').envInfo
var wxbarcode = require('../../codeUtils/index.js');

wxService.page({
  /**
   * 页面的初始数据
   */
  data: {
    sexArray:[
      {
        id:'1',
        name:'女'
      },{
        id:'2',
        name:'男'
      }
    ],
    sexIndex: 0,
    date:'',
    focus: false,
    memberCardNo: '',
    memberInfo: {},
    memberId: ''
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    // 取会员卡号
    const {memberCardNo, memberId} = wx.getStorageSync('_baseUserInfo')
    this.setData({
      memberCardNo,
      memberId
    })
    this.getMemberFind()
    // 条形码
    wxbarcode.barcode('barcode', memberCardNo, 500, 60);
  },

  formSubmit(e) {
    // 生日 0 女 1 男
    const { birthday } = this.data.memberInfo
    if(birthday) {
      e.detail.value.birthday = birthday
    }
    if(e.detail.value.sex == '0'){
      e.detail.value.sex = '女'
    } else {
      e.detail.value.sex = '男'
    }
    // e.detail.value.sex = e.detail.value.sex == '0' ? '女': '男'
    const params = e.detail.value

    this.handelMemberUplate(params)
    console.log('form发生了submit事件，携带数据为：', e.detail.value, params)
  },
  // 会员详情
  getMemberFind(){
    wx.showLoading({
      title: '加载中'
    })
    const params = {
      cardNoOnline: this.data.memberCardNo
    }
    wxService.post(`/member/find`,params).then(res => {
        const { result, data } = res.data
        if (result == 0) {
          wx.hideLoading()
          data.member.birthday = data.member.birthday.substring(0,10)
          this.setData({
            memberInfo: data.member
          })
        }
      })
  },
  // 更新
  handelMemberUplate(params){
    wx.showLoading({
      title: '加载中'
    })
    params.id = this.data.memberId 
    wxService.post(`/member/update`,params).then(res => {
        const { result, data } = res.data
        if (result == 0) {
          wx.hideLoading()
            wx.showToast({
              title: '保存成功',
              icon: 'success'
            })
        }else {
      wx.showToast({
        title: '保存失败',
        icon: 'none'
      })
    }
    })
  },
  bindTextAreaBlur: function(e) {
    console.log(e.detail.value)
  },
  //性别选择
  bindSexChange(e){
    this.setData({
      sexIndex: e.detail.value
    })
  },

  //日期选择
  bindDateChange(e) {
    this.setData({
      date: e.detail.value
    })
  },
  handleGoWxCard() {
    console.log('kabao')
    // wechatCardId wechatCode
    const { wechatCardId, wechatCode } = wx.getStorageSync('_baseUserInfo')
    wx.openCard({
      cardList: [{
        cardId: wechatCardId,
        code: wechatCode
      }],
      success(res) {
        console.log('查看微信卡包中的卡券', res)
      }
    })

  }
})